/* CS 106X Lecture 8: Recursion
 * -----------------
 * This program can recursively print out
 * the directory structure of any file path.
 */
#include <iostream>
#include "console.h"
#include "filelib.h"
#include "simpio.h"

using namespace std;

void crawl(const string& filename);
void crawl(const string& filename, const string& indent);

int main() {
    while (true) {
        string filename = getLine("Enter filename [ENTER] to quit: ");
        if (filename == "") {
            break;
        }

        crawl(filename);
    }

    cout << "Goodbye." << endl;
    return 0;
}

/**
 * Function: crawl
 * ---------------
 * Wrapper function around the recursive crawl that prints out
 * this file, and (if it is a directory), any files inside it,
 * indented one level.
 */
void crawl(const string& filename) {
    crawl(filename, "");
}

/**
 * Function: crawl
 * ---------------
 * Recursive function that prints out this file at the provided
 * indentation level, and (if it is a directory), any files inside it,
 * indented one level.
 */
void crawl(const string& filename, const string& indent) {
    cout << indent << getTail(filename) << endl;
    if (isDirectory(filename)) {
        // recursive case; print contained files/dirs
        Vector<string> filelist;
        listDirectory(filename, filelist);
        for (string subfile : filelist) {
            crawl(filename + "/" + subfile,
                  indent + "    ");
        }
    }
}


